# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/20_data.ipynb.

# %% auto 0
__all__ = ['array', 'tensor', 'nantensor', 'size', 'device', 'nnmodule', 'neuralode', 'neuralsde', 'neuraldynamics', 'odefunc',
           'sdefunc', 'sdeito', 'brownianintervial', 'groupkey', 'indextype', 'indexlike', 'catindex', 'boolindex',
           'seriestype', 'serieslike', 'serialized', 'datatype', 'shaped', 'graphtype']

# %% ../nbs/20_data.ipynb 6
#| export


# %% ../nbs/20_data.ipynb 8
from typing import TypeAlias

# %% ../nbs/20_data.ipynb 10
#| export


# %% ../nbs/20_data.ipynb 12
from ptyp import Alias, Not

from itry import ptnan
from itry import npmatrix, nparray, recarray, sparray, spmatrix, anndata
from itry import bgraph, dgraph, kgraph, tgraph, lgraph, mgraph, tlgraph, klgraph, mlgraph
from itry import pdindex, pdseries, pdcatindex, pddataframe
from itry import pttensor, ptinttensor, ptbooltensor, ptfloattensor

from itry import ptsize, ptmodule, plmodule, ptdevice
from itry import sdeito as ito, brownianinterval as brownian
from itry import (
    odefunc as odefn, sdefunc as sdefn, augmenter, 
    neuralode as neurode, neuralsde as neursde)

# %% ../nbs/20_data.ipynb 14
from .iter import itertype
from .bool import bools, bool01
from .nums import num, nums, numstr
from .nans import nans, nan

# %% ../nbs/20_data.ipynb 16
@Alias(nparray, recarray, sparray, itertype, list)
class array: ...

# %% ../nbs/20_data.ipynb 17
@Alias(pttensor, ptinttensor, ptbooltensor, ptfloattensor)
class tensor: ...

@Alias(tensor, nans, attrs=dict(dtype=nan))
class nantensor: ...

# %% ../nbs/20_data.ipynb 18
@Alias(tuple, ptsize, itertype, attrs=dict(dtype=int))
class size: ...

@Alias(ptdevice, str, None, mapattrs=('type', lambda x: not isinstance(x, str) and hasattr(x, 'type')))
class device: ...

@Alias(ptmodule, plmodule)
class nnmodule: ...

@Alias(neurode)
class neuralode: ...

@Alias(neursde)
class neuralsde: ...

@Alias(neuralode, neuralsde)
class neuraldynamics: ...

@Alias(odefn)
class odefunc: ...

@Alias(sdefn)
class sdefunc: ...


@Alias(ito)
class sdeito: ...

@Alias(brownian)
class brownianintervial: ...

# %% ../nbs/20_data.ipynb 19
@Alias(str, tuple, num, attrs=dict(dtype=numstr))
class groupkey: ...

# %% ../nbs/20_data.ipynb 20
@Alias(list, bools, nums, itertype, pdindex, pdcatindex, nparray)
class indextype: ...

@Alias(indextype)
class indexlike: ...

@Alias(pdcatindex)
class catindex: ...

@Alias(indexlike, nparray, list, attrs=dict(dtype=bool01))
class boolindex: ...

# %% ../nbs/20_data.ipynb 21
@Alias(pdseries, nparray, recarray, list, indexlike)
class seriestype: ...

@Alias(seriestype)
class serieslike: ...

@Alias(seriestype)
class serialized: ...

# %% ../nbs/20_data.ipynb 22
@Alias(npmatrix, nparray, recarray, sparray, spmatrix, anndata)
class datatype: ...

@Alias(datatype, pdindex, pdseries, pdcatindex, pddataframe, tensor, hasattrs=('shape', ))
class shaped: ...

# %% ../nbs/20_data.ipynb 23
@Alias(bgraph, dgraph, kgraph, tgraph, lgraph, mgraph, tlgraph, klgraph, mlgraph)
class graphtype: ...
